﻿Type=StaticCode
Version=1.70
@EndOfDesignText@
'Version 1.04
Sub Process_Globals
	Dim Tasks As List 'List of URLs to fetch.
	'A map that holds the successful links.
	'The links are stored as keys. The values are not used.
	Dim SuccessfulUrls As Map 
	Dim Working As Boolean 'True when a job is still running
	Dim Complete As Boolean 'True after a job has completer
	Dim Job As String 'Name of the current running Job
	Dim CallbackActivity As String 'Name of Activity that handles the callbacks.
	Dim CallbackJobDoneSub As String 'Name of the JobDone callback sub.
	Dim CallbackUrlDoneSub As String 'Name of the UrlDone callback sub.
End Sub

'Sends a POST request with the given string as the post data
Sub PostString(JobName As String, URL As String, Text As String)
	PostBytes(JobName, URL, Text.GetBytes("UTF8"))
End Sub
'Sends a POST request with the given data as the post data.
Sub PostBytes(JobName As String, URL As String, Data() As Byte)
	If internalCheckIfCanStart(JobName) = False Then Return
	HttpUtilsService.PostInputStream = Null
	HttpUtilsService.PostBytes = Data
	Tasks = Array As String(URL)
	HttpUtilsService.Post = True
	StartService(HttpUtilsService)
End Sub
'Get methods should be called only after the JobDone event or the UrlDone event.
Sub GetString(URL As String) As String
	If IsSuccess(URL) = False Then
		Log("Task not completed successfully.")
		Return ""
	End If
	Return File.GetText(HttpUtilsService.TempFolder, SuccessfulUrls.Get(URL))
End Sub

Sub GetInputStream(URL As String) As InputStream
	Dim in As InputStream
	If IsSuccess(URL) = False Then
		Log("Task not completed successfully.")
		Return in
	End If
	in = File.OpenInput(HttpUtilsService.TempFolder, SuccessfulUrls.Get(URL))
	Return in
End Sub